OCH     EQU #C000+6912+6912 ;ScrPage

CnkPgn
        DISP PgnAdr

BCnk    LD A,%1111
bcnk    LD IX,WCnk
        LD (IX+6),A
        LD SP,(SPP)
        CALL Win_
        CP #FF
        JP Z,RES_TSK2
        LD BC,TBCnk
        JP TAB_JP

bcnk_   LD A,%1101
        JR bcnk

TBCnk   DEFW SCRCHN
        DEFW CHNSCR
        DEFW LkCnk
        DEFW Dldcnk
        DEFW Dsvcnk
        DEFW LIGHT
        DEFW DCN

DCN     CALL Driver
        JR bcnk_

WCnk    DEFB 11,2,9,11,3*8+7,7*8,%00001111
; Bit 0 -   /
; Bit 1 - ""  /
; Bit 2 -     /
; Bit 3 -   -     (CANCEL)
        DEFB 0
        DEFW TCnk         ; -
        DEFW SCnk         ; - ()
        DEFW #FFFF

SCnk    ; DEFB 1,3,7,1,%11
        ; DEFB 1,4,7,1,%11
        ; DEFB 1,5,7,1,%11
        ; DEFB 1,6,7,1,%11
        ; DEFB 1,7,7,1,%11
        ; DEFB 1,8,7,1,%11
        ; DEFB 1,9,7,1,%11
        DB 1,3,7,128+7,%11
        DEFB #FF

TCnk
  ;  if rus                        ;    /DA
  ;      DB #84,#a8,#a7,#a5,#e0,#a8,#ad,#a3,13;"",13
  ;      DB #8a,#ae,#ad,#a2,#a5,#e0,#e2,#a0,#e6,#a8,#ef,13;"",13
  ;      DB #8d,#a0,#20,#ed,#aa,#e0,#a0,#ad,13;" ",13
  ;      DB #8f,#e0,#ae,#e1,#ac,#ae,#e2,#e0,#a5,#e2,#ec,13;"",13
  ;      DB #8e,#e2,#aa,#e0,#eb,#e2,#ec,#5f,13;"_",13
  ;      DB #91,#ae,#e5,#e0,#a0,#ad,#a8,#e2,#ec,#5f,13;"_",13
  ;      DB #9f,#e0,#aa,#ae,#e1,#e2,#ec,13;"",13
  ;      DB #84,#a8,#e1,#aa,#ae,#a2,#ae,#a4,0;"",0
  ;  else
  ;      DB "Dithering",13
  ;      DB "Convert",13
  ;      DB "To screen",13
  ;      DB "View",13
  ;      DB "Load_",13
  ;      DB "Save_",13
  ;      DB "Brightness",13
  ;      DB "Drive",0
  ;  endif
        MSG_Cnk_Dith : DB 13
        MSG_Cnk_Convert : DB 13
        MSG_Cnk_Toscr : DB 13
        MSG_Cnk_View : DB 13
        MSG_DISK_Load_ : DB 13
        MSG_DISK_Save_ : DB 13
        MSG_Cnk_Bright : DB 13
        MSG_DISK_drive :DB 0

Dldcnk  LD HL,SORTcnk
        CALL FilerE
        JP C,bcnk_
        LD B,#0C
        EXLOAD #8000,AddAdr+5,START_SEC,AddPage
        JP C,bcnk_
        CALL CnkID
        LD DE,FNCnk
        CALL ToName
        JP bcnk_

SORTcnk DB 0,#0C,#FF

FNCnk   DB "noname  dit"

nocnk_  POP AF
nocnk   CALL NoData_
        JP bcnk_

Dsvcnk  CALL TstID
        JP NZ,nocnk
        LD HL,FNCnk
        CALL FNEdit
        JP C,bcnk_
        LD HL,FNCnk
        CALL FromName
        LD B,#0C
        EXSAVEF #8000,AddAdr+5,#0C00,AddPage
        JP C,bcnk_
        JP bcnk_

CH_0    DEFB 1

LIGHT   CALL NOKEY_
        CALL SV_UNDO
        CALL LOADSCR
        LD A,ScrPage
        CALL RAM
        LD A,17
        LD (LEVEL_CNK),A
        LD IX,CT+136;                 ; -
        LD HL,OCH; adres(#d800)
        LD B,L      ; -
Lp5     LD (HL),#1A ;,  -
        INC HL       ;   
        LD (HL),#A1 ; -
        INC HL       ; 
        LD (HL),#77
        INC HL
        LD (HL),#2C
        INC HL
        LD (HL),#1C
        INC HL
        DJNZ Lp5
        LD (HL),#24
        INC HL
        LD (HL),#14
        INC HL
        LD (HL),#C9

U1      CALL DIRSCN_
        BIT 2,A
        JR NZ,DNCNK
        BIT 3,A
        JR NZ,UPCNK
        LD A,BUTTON
        CALL GUI
        AND A
        JP NZ,END_CNK
        HALT
        JR U1

UPCNK   LD A,0
LEVEL_CNK EQU $-1
        CP 17
        JR Z,U1
        INC A
        LD (LEVEL_CNK),A
        LD BC,#0008
        ADD IX,BC
        CALL OUT_CK
        JR U1

DNCNK   LD A,(LEVEL_CNK)
        OR A
        JR Z,U1
        DEC A
        LD (LEVEL_CNK),A
        LD BC,#0008
        PUSH IX
        POP HL
        SBC HL,BC
        PUSH HL
        POP IX
        CALL OUT_CK
        JR U1

END_CNK EQU RES_TSK4

OUT_CK  LD HL,#4000
        LD DE,#C000
        LD B,#03
U2      LD C,(IX+#00)
        CALL OCH
        LD C,(IX+#01)
        CALL OCH
        LD C,(IX+#02)
        CALL OCH
        LD C,(IX+#03)
        CALL OCH
        LD C,(IX+#04)
        CALL OCH
        LD C,(IX+#05)
        CALL OCH
        LD C,(IX+#06)
        CALL OCH
        LD C,(IX+#07)
        CALL OCH
        DJNZ U2
        RET

CnkID   LD A,AddPage
        CALL RAM
        LD HL,cnkid
        LD DE,AddAdr
        LD BC,5
        LDIR
        RET

;SCREEN TO CHANK
;---------------------------------
SCRCHN  CALL LOADSCR
        CALL CnkID

        LD DE,#4000
        LD IX,AddAdr+5
        LD B,#30
BEG_P   PUSH DE
        LD C,#20
U3      PUSH BC
        PUSH DE
        LD A,#04
        LD HL,#0000
U4      EX AF,AF'
        LD A,(DE)
        LD C,A
        LD B,#04
L7      RLCA
        JR NC,n_2
        INC H
n_2     RRC C
        JR NC,n_3
        INC L
n_3     DJNZ L7
        EX AF,AF'
        INC D
        DEC A
        JR NZ,U4
        LD A,H
        CP #10
        JR NZ,n_4
        LD H,#0F
n_4     LD A,L
        CP #10
        JR NZ,n_5
        LD L,#0F
n_5     LD (IX+#00),H
        LD (IX+#01),L
        INC IX
        INC IX
        POP DE
        POP BC
        INC E
        DEC C
        JP NZ,U3
        POP DE
        LD A,D
        ADD A,#04
        LD D,A
        AND #07
        JR NZ,n_1
        LD A,E
        ADD A,#20
        LD E,A
        JR C,n_1
        LD A,D
        SUB #08
        LD D,A
n_1     DJNZ BEG_P
LkCnk   CALL CHN_SCRR
        CALL ReWin
        JP BCnk
;CHANK TO SCREEN
;---------------------------------
CHNSCR  CALL SV_UNDO
        CALL CHN_SCRR
        JP RES_TSK4

TstID   LD A,AddPage
        CALL RAM
        LD HL,AddAdr
        LD A,(HL)
        CP "C"
        RET NZ
        INC HL
        LD A,(HL)
        CP "H"
        RET NZ
        INC HL
        LD A,(HL)
        CP "A"
        RET NZ
        INC HL
        LD A,(HL)
        CP "N"
        RET NZ
        INC HL
        LD A,(HL)
        CP "K"
        RET

CHN_SCRR
        CALL TstID
        JP NZ,nocnk_
        CALL CLS
        LD A,AddPage
        CALL RAM
        LD IX,AddAdr+5
        LD DE,#4000
        LD C,#30
Bg1     PUSH DE
        LD B,#20
Lp1     PUSH BC
        PUSH DE
        LD A,(IX+#00)
        CP #10
        JR C,Nx3
        CP #E1
        LD A,#0F
        JR  C,Nx3
        XOR A
Nx3     INC IX
        ADD A,A
        ADD A,A
        LD HL,CTB
        LD C,A
        LD B,#00
        ADD HL,BC
        LD B,#04
Lp3     LD A,(HL)
        AND #F0
        LD (DE),A
        INC D
        INC HL
        DJNZ Lp3
        DEC D
        LD A,(IX+#00)
        CP #10
        JR C,Nx2
        CP #E1
        LD A,#0F
        JR C,Nx2
        XOR A
Nx2     INC IX
        ADD A,A
        ADD A,A
        ADD A,#03
        LD HL,CTB
        LD C,A
        LD B,#00
        ADD HL,BC
        LD B,#04
        EX DE,HL
Lp2     LD A,(DE)
        AND #0F
        OR (HL)
        LD (HL),A
        DEC H
        DEC DE
        DJNZ Lp2
        EX DE,HL
        POP DE
        POP BC
        INC E
        DJNZ Lp1
        POP DE
        LD  A,D
        ADD A,#04
        LD D,A
        AND #07
        JR NZ,Nx1
        LD A,E
        ADD A,#20
        LD E,A
        JR C,Nx1
        LD A,D
        SUB #08
        LD D,A
Nx1     DEC C
        JP NZ,Bg1
        JP WAITKEY_

;################################
;--------------   ...
BMask   LD A,%1111
bmask   LD IX,WMask
        LD (IX+6),A
        CALL Win_
        CP #FF
        JP Z,RES_TSK2
        LD BC,TBMask
        JP TAB_JP

bmask_  LD A,%1101
        JR bmask

WMask   DB 13,2,9,11,2*8+6,6*8,%1111      ; DEFB 13,2,8,9,2*8+6,6*8,%00001111
; Bit 0 -   /
; Bit 1 - ""  /
; Bit 2 -     /
; Bit 3 -   -     (CANCEL)
        DEFB 0
        DEFW TMask        ; -
        DEFW SMask        ; - ()
        DEFW Nil          ;  
        DEFW Nil          ; - ()
        DEFW SwMask       ; -
        DEFW #FFFF

; +14
; x, y,  ,  (#00/#FF)
SwMask
  ;  if rus
  ;      DEFB 4,7,3,0
  ;  else
  ;      DEFB 6,7,3,0
  ;  endif
         DB 7,8,4,0         ;  2- - /DA
swmask2 EQU $-1
         DW Nil             ; DEFW Nil
         DB 7,9,5,0         ; DEFB #FF
swmask  EQU $-1
         DW Nil
         DB #FF

SMask     ; DB 1,3,7,1,%11  ; DEFB 1,3,6,1,%11
          ; DB 1,4,7,1,%11  ; DEFB 1,4,6,1,%11
          ; DB 1,5,7,1,%11  ; DEFB 1,5,6,1,%11
          ; DB 1,6,7,1,%11
          DB 1,3,7,128+4,%11
          ; DB 1,8,7,1,%11
          ; DB 1,9,7,1,%11  ; DEFB 1,7,6,1,%10
          DB 1,8,7,128+2,%11
          DB #FF          ; DEFB #FF

TMask
;    if rus                           ;    +   /DA
;        DB #8d,#a0,#ab,#ae,#a6,#a5,#ad,#a8,#a5,13;"",13
;        DB "2-",#a9,#20,#ed,#aa,#e0,#a0,#ad,13; ",13
;        DB #84,#a8,#a7,#a5,#e0,#a8,#ad,#a3,13;"",13
;        DB #94,#a0,#a9,#ab,#5f,13;"_",13
;        DB 15,13
;        DB #8e,#aa,#ad,#ae,#20,0;" ",0
;    else
;        DB "Mixing",13
;        DB "2 screen",13
;        DB "Chunk",13
;        DB "File_",13
;        DB 15,13
;        DB "Window",0
;    endif
;
          MSG_Mix_Mixing : DB 13
          MSG_Mix_2screen : DB 13
          MSG_Mix_Chunk : DB 13
          MSG_Mix_Txtr : DB 13
          MSG_Mix_File : DB 13
          DB 15,13
          MSG_Mix_Scr2msk : DB 13
          MSG_Mix_Window : DB 0


WMMeth  DEFB 14,4,4,5,5*8,5,%00001110
; Bit 0 -   /
; Bit 1 - ""  /
; Bit 2 -     /
; Bit 3 -   -     (CANCEL)
        DEFB 0
        DEFW TMMeth       ; -
        DEFW SMMeth       ; - ()
        DEFW #FFFF

SMMeth  ; DEFB 1,1,2,1,%11
        ; DEFB 1,2,2,1,%11
        ; DEFB 1,3,2,1,%11
        DB 1,1,2,128+3,%11
        DEFB #FF

TMMeth  DB "Or",13
        DB "Xor",13
        DB "And",0

TBMask  DW MRA
        DW MCN
        DW MixTxtr   ; c  /DA
        DW MSKLD
;       DW CHM

MMeth   LD IX,WMMeth
        CALL Win_
        PUSH AF
        CALL NOKEY_
        CALL CLOSE
        POP AF
        CP #FF
        JP Z,scf
        LD BC,MA
        CALL TAB_HL
        CALL JP_HL
        XOR A
        RET

MA      DEFW Or
        DEFW Xo
        DEFW An

An      LD A,#A6
        LD (MDE),A
        RET
Xo      LD A,#AE
        JR An+2
Or      LD A,#B6
        JR An+2

MSKLD   CALL MMeth
        JP C,bmask_
        AND A
        RET NZ
        LD HL,SORTscr
        CALL FilerE
        JP C,bmask
       ; CALL CLS   ; /DA
        LD HL,#4000
        LD DE,(START_SEC)
        LD C,14
        LD A,(SEC_LEN)
        LD B,A
        CALL DOS_FUNC_
        JP C,Main
      ;  LD A,ScrPage
      ;  CALL RAM
      ;  JP RET2
        jr MRA.rscr
;.....................................
MCN     CALL TstID
        JP NZ,bmask_
        CALL MMeth
        JP C,bmask_
       ; CALL CLS
        CALL CHN_SCRR
      ;  LD A,ScrPage
      ;  CALL RAM
      ;  JR RET2
        jr MRA.rscr

; MRA     CALL MMeth           ; /DA
MRA      xor a                ;      
         ld (swmask2),a
         call MMeth
        JP C,bmask_
       ; CALL CLS
        LD A,RamPage
        CALL RAM
        LD HL,#C000
        LD DE,#4000
        LD BC,6912
        LDIR
.rscr  ; LD A,ScrPage
       ; CALL RAM
        call ScrRam
RET2    CALL SV_UNDO
        LD HL,SCREEN+6144
        LD DE,#5800
        LD BC,768
        LDIR
           call ERASE_ALLW   ; /DA
        LD HL,SCREEN
        LD DE,#4000
        LD BC,6144
;c6      LD A,(DE)           ;   /DA
;MDE     AND (HL)
;        LD (DE),A
;        INC HL
;        INC DE
;        DEC BC
;        LD A,C
;        OR B
;        JR NZ,c6
           call c6
            ld a,(swmask2)           ;  2-    ?  /DA
            or a
           jr z,.n2ms
            ld a,RamPage
            call RAM
            ld a,#A6       ; and (hl)
            ld (MDE),a
            call c6        ;  
            ld a,#B6       ; or (hl)
            ld a,SuxPage   ;     
            call SAVESCR.save
            call LOADSCR2
            ld hl,#4000
            ld bc,6144
1           ld a,(hl)
            cpl
            ld (hl),a
            inc hl
            dec bc
            ld a,b
            or c
           jr nz,1B
            call ScrRam
            call c6
            ld a,#B6       ; or (hl)
            ld (MDE),a
            call SuxRam
            call c6
            ld bc,768
            ldir
.n2ms
        LD A,(swmask)
        AND A
        CALL NZ,SwM
        JP RES_TSK4

MixTxtr    call MMeth    ; /DA  -   
          jp c,bmask_
           call Texture
          jp c,bmask_

           ld b,12         ;    
           ld hl,#4000
1          push bc
           ld de,TBUFF
            ld b,16
2          push hl
           push bc
            ld b,16
3          ld a,(de)
           ld (hl),a
           inc de
           inc l
           ld a,(de)
           ld (hl),a
           dec de
           inc l
          djnz 3B
           pop bc
           pop hl
           call INC_Y
           inc de
           inc de
          djnz 2B
           pop bc
          djnz 1B
         jp MRA.rscr

c6      LD HL,SCREEN
        LD DE,#4000
        LD BC,6144
1       LD A,(DE)
MDE     AND (HL)
        LD (DE),A
        INC HL
        INC DE
        DEC BC
        LD A,C
        OR B
        JR NZ,1B
        ret

SwM     LD IX,MRmk
        CALL R8Sel
        JP C,RES_TSK
        CALL SuxRam
        LD IX,MRmk
        LD DE,#C000
        CALL SaveWS
        CALL LOADSCR
        CALL SuxRam
        LD DE,#C000
        JP LoadWS

LCnk    EQU $-BCnk
        ENT

       DISPLAY "Chnk len   :",/a,LCnk
